/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Image-EXIF.xs. Do not edit this file, edit Image-EXIF.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Image-EXIF.xs"
#define PERL_NO_GET_CONTEXT

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "exif.h"
#include "jpeg.h"

struct impl {
    SV *file_name;
    struct exiftags *et;
};

typedef struct impl *Image__EXIF;

#ifndef Newxz
#define Newxz(ptr, n, type) Newz(705, ptr, n, type)
#endif

static void
load(pTHX_ struct impl *impl, const char *name)
{
    int mark, first = 0;
    unsigned int len, rlen;
    unsigned char *exifbuf = NULL;
    FILE *fp = fopen(name, "rb");

    if (!fp)
        croak("Can't open file %s: %s", name, strerror(errno));

    while (jpegscan(fp, &mark, &len, !(first++))) {
        if (mark != JPEG_M_APP1) {
            if (fseek(fp, len, SEEK_CUR)) {
                free(exifbuf);
                fclose(fp);
                croak("Can't seek in file %s: %s", name, strerror(errno));
            }
            continue;
        }

        exifbuf = (unsigned char *) malloc(len);
        if (!exifbuf) {
            fclose(fp);
            croak("malloc failed");
        }

        rlen = fread(exifbuf, 1, len, fp);
        if (rlen != len) {
            free(exifbuf);
            fclose(fp);
            croak("error reading JPEG %s: length mismatch", name);
        }

        impl->et = exifparse(exifbuf, len);
        break;
    }

    if (impl->et && !impl->et->props) {
        exiffree(impl->et);
        impl->et = 0;
    }

    free(exifbuf);
    fclose(fp);
}

static STRLEN
trimmed_len(const char *p)
{
    const char *endp = p + strlen(p);
    while (endp > p) {
        endp--;
        if (!isspace(*endp))
            return endp - p + 1;
    }
    return 0;
}

static SV *
get_props(pTHX_ struct impl *impl, unsigned short lvl)
{
    struct exifprop *ep;
    HV *hv = 0;

    if (!impl->file_name)
        croak("no Image::EXIF data loaded");

    if (!impl->et)
        return &PL_sv_undef;

    for (ep = impl->et->props;  ep;  ep = ep->next) {
        const char *name;

        if (ep->lvl == ED_PAS)
            /* Take care of point-and-shoot values. */
            ep->lvl = ED_CAM;
        else if (ep->lvl == ED_OVR || ep->lvl == ED_BAD)
            /* For now, just treat overridden & bad values as verbose. */
            ep->lvl = ED_VRB;

        if (ep->lvl != lvl)
            continue;

        name = ep->descr ? ep->descr : ep->name;
        if (!name || !*name)
            continue;

        if (!hv)
            hv = newHV();

        hv_store(hv, name, strlen(name),
                 ep->str ? newSVpvn(ep->str, trimmed_len(ep->str))
                 :         newSViv(ep->value), 0);
    }

    return hv ? newRV_noinc((SV *) hv) : &PL_sv_undef;
}

#line 130 "Image-EXIF.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 274 "Image-EXIF.c"

XS_EUPXS(XS_Image__EXIF__new_instance); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__EXIF__new_instance)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "package");
    {
	char *	package = (char *)SvPV_nolen(ST(0))
;
	Image__EXIF	RETVAL;
#line 128 "Image-EXIF.xs"
    struct impl *impl;
    Newxz(impl, 1, struct impl);
    RETVAL = impl;
#line 290 "Image-EXIF.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, "Image::EXIF", (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__EXIF__destroy_instance); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__EXIF__destroy_instance)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "impl");
    {
	Image__EXIF	impl;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Image::EXIF")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    impl = INT2PTR(Image__EXIF,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Image::EXIF::_destroy_instance",
			"impl", "Image::EXIF")
;
#line 138 "Image-EXIF.xs"
    if (impl->file_name)
        SvREFCNT_dec(impl->file_name);
    if (impl->et)
        exiffree(impl->et);
    Safefree(impl);
#line 326 "Image-EXIF.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Image__EXIF__load_file); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__EXIF__load_file)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "impl, file_name");
    {
	Image__EXIF	impl;
	SV *	file_name = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Image::EXIF")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    impl = INT2PTR(Image__EXIF,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Image::EXIF::_load_file",
			"impl", "Image::EXIF")
;
#line 149 "Image-EXIF.xs"
    load(aTHX_ impl, SvPV_nolen(file_name));
    impl->file_name = SvREFCNT_inc(file_name);
#line 355 "Image-EXIF.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Image__EXIF__file_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__EXIF__file_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "impl");
    {
	Image__EXIF	impl;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Image::EXIF")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    impl = INT2PTR(Image__EXIF,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Image::EXIF::_file_name",
			"impl", "Image::EXIF")
;
#line 156 "Image-EXIF.xs"
    RETVAL = newSVsv(impl->file_name);
#line 382 "Image-EXIF.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__EXIF_get_camera_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__EXIF_get_camera_info)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "impl");
    {
	Image__EXIF	impl;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Image::EXIF")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    impl = INT2PTR(Image__EXIF,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Image::EXIF::get_camera_info",
			"impl", "Image::EXIF")
;
#line 164 "Image-EXIF.xs"
    RETVAL = get_props(aTHX_ impl, ED_CAM);
#line 411 "Image-EXIF.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__EXIF_get_image_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__EXIF_get_image_info)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "impl");
    {
	Image__EXIF	impl;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Image::EXIF")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    impl = INT2PTR(Image__EXIF,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Image::EXIF::get_image_info",
			"impl", "Image::EXIF")
;
#line 172 "Image-EXIF.xs"
    RETVAL = get_props(aTHX_ impl, ED_IMG);
#line 440 "Image-EXIF.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__EXIF_get_other_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__EXIF_get_other_info)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "impl");
    {
	Image__EXIF	impl;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Image::EXIF")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    impl = INT2PTR(Image__EXIF,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Image::EXIF::get_other_info",
			"impl", "Image::EXIF")
;
#line 180 "Image-EXIF.xs"
    RETVAL = get_props(aTHX_ impl, ED_VRB);
#line 469 "Image-EXIF.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Image__EXIF_get_unknown_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Image__EXIF_get_unknown_info)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "impl");
    {
	Image__EXIF	impl;
	SV *	RETVAL;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Image::EXIF")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    impl = INT2PTR(Image__EXIF,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Image::EXIF::get_unknown_info",
			"impl", "Image::EXIF")
;
#line 188 "Image-EXIF.xs"
    RETVAL = get_props(aTHX_ impl, ED_UNK);
#line 498 "Image-EXIF.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Image__EXIF); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Image__EXIF)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Image::EXIF::_new_instance", XS_Image__EXIF__new_instance);
        newXS_deffile("Image::EXIF::_destroy_instance", XS_Image__EXIF__destroy_instance);
        newXS_deffile("Image::EXIF::_load_file", XS_Image__EXIF__load_file);
        newXS_deffile("Image::EXIF::_file_name", XS_Image__EXIF__file_name);
        newXS_deffile("Image::EXIF::get_camera_info", XS_Image__EXIF_get_camera_info);
        newXS_deffile("Image::EXIF::get_image_info", XS_Image__EXIF_get_image_info);
        newXS_deffile("Image::EXIF::get_other_info", XS_Image__EXIF_get_other_info);
        newXS_deffile("Image::EXIF::get_unknown_info", XS_Image__EXIF_get_unknown_info);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

